#!/bin/sh
#Automation 1.1
#daniel.uramg 07/04/2010
. /var/http/web-functions

if [ -n "$LANGUAGE_WEBADMIN" ]; then
  LC=`echo $LANGUAGE_WEBADMIN`
  [ -e "/etc/automation/language.$LC" ] && . /etc/automation/language.$LC || . /etc/automation/language.ENU
else
 . /etc/automation/language.ENU
fi

SCRIPT=automation.cgi
D1=`date +%d/%m/%Y`
H1=`date +%H:%M`
DIAHOY="$D1 - $H1"
ULTIMA_ID=`cat /etc/coyote/subnet.cfg | sed '$!d' | tr -s ' ' | cut -d " " -f 3`
ULTIMA_LANID=`cat /etc/coyote/subnet.cfg | sed '$!d' | tr -s ' ' | cut -d " " -f 13`
USAR_ID=`echo $(($ULTIMA_ID+1))`
LANID=`echo $(($ULTIMA_LANID+1))`
VERIF_USER_DHCP=`grep "$FORM_USER" /etc/dhcpd.reservations`
VERIF_MAC_DHCP=`grep "$FORM_MAC" /etc/dhcpd.reservations`
VERIF_IP_DHCP=`cat /etc/dhcpd.reservations | cut -f 3 -d, | grep "$FORM_IP"$`
VERIF_IP_DHCP2=`cat /etc/dnsmasq.conf.template | cut -f 2 -d, | grep "$FORM_IP"$`
VERIF_IP_FIREWALL=`cat /etc/coyote/firewall | cut -f 2 -d" " | grep "$FORM_IP"$`
VERIF_MAC_FIREWALL=`grep "$FORM_MAC" /etc/coyote/firewall`
VERIF_USER_EC=`grep "$FORM_USER" /usr/local/easycaptive/config/passwd`
VERIF_IP_EC=`cat /usr/local/easycaptive/config/passwd | cut -f 3 -d: | grep "$FORM_IP"$`
VERIF_IP_QOS=`cat /etc/coyote/qos.classes | cut -f 8 -d" " | grep "$FORM_IP"$`

cl_header2 "Automation - BrazilFW Linux";

#==================================
find_lan() {
 case "$1" in
	LAN1)	LAN="LAN1" ;;
	LAN2)	LAN="LAN2" ;;
	LAN3)	LAN="LAN3" ;;
	LAN4)	LAN="LAN4" ;;
	WLAN)	LAN="WLAN" ;;
	DMZ)	LAN="DMZ" ;;
	*)	LAN="LAN1" ;;
 esac
}
#==================================

##>>
#REMOVER
	if [ "$FORM_REMOVER" = "$ATaag" ]; then
		if [ ${#FORM_USER} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Ius</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_DESCADASTRAR" != "ON" ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaab</div></b></center></tr>
</body>
CLEOF
	elif [ -e /etc/automation/clientes/$FORM_USER ]; then
/bin/sh /etc/automation/clientes/$FORM_USER
cat << CLEOF
<body>
<tr><center><div id=alerta>$ATaac $FORM_USER $ATaad<br>$Wta</div></center></tr>
</body>
CLEOF
cl_rebuildconf
	else
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaae ($FORM_USER)</div></b></center></tr>
</body>
CLEOF
	fi
		fi
##<<

##>>
#CADASTRAR
	if [ "$FORM_ENVIAR" = "$ATaaf" ]; then
#>>
#VERIFICAES
	if [ ${#FORM_USER} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Ius</div></b></center></tr>
</body>
CLEOF
	elif [ -e /etc/automation/clientes/$FORM_USER ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaah ($FORM_USER)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#FORM_IP} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : IP</div></b></center></tr>
</body>
CLEOF
	elif [ ${#FORM_MAC} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : MAC</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_USER_DHCP} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaah ($FORM_USER)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_MAC_DHCP} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaai</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_IP_DHCP} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaaj (/etc/dhcpd.reservations)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_IP_DHCP2} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaaj (/etc/dnsmasq.conf.template)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_IP_QOS} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaaj (/etc/coyote/qos.classes)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_IP_FIREWALL} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaaj (/etc/coyote/firewall)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_MAC_FIREWALL} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaai</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_USER_EC} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaah ($FORM_USER)</div></b></center></tr>
</body>
CLEOF
	elif [ ${#VERIF_IP_EC} != 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaaj (/usr/local/easycaptive/config/passwd)</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_DHCP" = "ON" -a ${#FORM_LEASE} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Fab</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "SUBREDES" -a ${#FORM_GATEWAY} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : Gateway</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "SUBREDES" -a ${#FORM_MASK} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Anm</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "SUBREDES" -a ${#FORM_UP_MIN} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Phk</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "SUBREDES" -a ${#FORM_UP_MAX} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Phl</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "SUBREDES" -a ${#FORM_DOWN_MIN} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Phi</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "SUBREDES" -a ${#FORM_DOWN_MAX} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : $Phj</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "QoS" -a ${#FORM_UP_MIN} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$$ATaao : IP</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "QoS" -a ${#FORM_UP_MAX} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaar</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "QoS" -a ${#FORM_DOWN_MIN} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaar</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_modo_qos" = "QoS" -a ${#FORM_DOWN_MAX} = 0 ]; then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaas</div></b></center></tr>
</body>
CLEOF
	elif [ "$FORM_EC" = "ON" -a ${#FORM_DATA} = 0 ];then
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaao : Data</div></b></center></tr>
</body>
CLEOF

#<<
	else
#>>
#CRIA ARQUIVO
echo "#/bin/sh
#Automation 1.0 daniel.uramg
#Script de desregistro de usurio

#Data de registro: $DIAHOY
#User: $FORM_USER
#MAC: $FORM_MAC
#IP: $FORM_IP
#Data Pagamento: $FORM_DATA
#Gateway: $FORM_GATEWAY
#Up Mnimo: $FORM_UP_MIN
#Up Mximo: $FORM_UP_MAX
#Down Mnimo: $FORM_DOWN_MIN
#Down Mximo: $FORM_DOWN_MAX
" > /etc/automation/clientes/$FORM_USER
#>>
#DHCP
	if [ "$FORM_DHCP" = "ON" ]; then
echo "dhcp-host=$FORM_MAC,$FORM_USER,$FORM_IP,$FORM_LEASE" >> /etc/dhcpd.reservations
echo "dhcp-range=$FORM_IP,$FORM_IP" >> /etc/dnsmasq.conf.template
echo "sed -i '/$FORM_USER,/d' /etc/dhcpd.reservations" >> /etc/automation/clientes/$FORM_USER
echo "sed -i '/$FORM_IP,/d' /etc/dnsmasq.conf.template" >> /etc/automation/clientes/$FORM_USER
echo "/etc/rc.d/rc.dnsmasq > /dev/null" >> /etc/automation/clientes/$FORM_USER
/etc/rc.d/rc.dnsmasq > /dev/null
	fi
#<<
#>>
#FIREWALL
	if [ "$FORM_FIREWALL" = "ON" ]; then
echo "match_ip_mac $FORM_IP $FORM_MAC" >> /etc/coyote/firewall
echo "sed -i '/$FORM_IP /d' /etc/coyote/firewall" >> /etc/automation/clientes/$FORM_USER
echo "/etc/rc.d/rc.firewall > /dev/null" >> /etc/automation/clientes/$FORM_USER
/etc/rc.d/rc.firewall > /dev/null
	fi
#<<
#>>
#EASY CAPTIVE
	if [ "$FORM_EC" = "ON" ]; then
/usr/local/easycaptive/bin/./easycaptive ADD "$FORM_USER" "0" "$FORM_IP" "$FORM_EC_METD" "0" "$FORM_DATA" "P" > /dev/null
echo "/usr/local/easycaptive/bin/./easycaptive DEL "$FORM_USER" > /dev/null" >> /etc/automation/clientes/$FORM_USER
	fi
#<<
#>>
#SUBREDES
	if [ "$FORM_modo_qos" = "SUBREDES" ]; then
echo "subnet y $USAR_ID $FORM_GATEWAY $FORM_MASK y y $FORM_DOWN_MIN $FORM_DOWN_MAX $FORM_UP_MIN $FORM_UP_MAX $FORM_LAN  $LANID $FORM_CONLIMIT #$FORM_USER" >> /etc/coyote/subnet.cfg
echo "sed -i '/$FORM_GATEWAY /d' /etc/coyote/subnet.cfg" >> /etc/automation/clientes/$FORM_USER
echo "/etc/rc.d/rc.subnet > /dev/null" >> /etc/automation/clientes/$FORM_USER
/etc/rc.d/rc.subnet > /dev/null
	fi
#<<
#>>
#QOS
	if [ "$FORM_modo_qos" = "QoS" ]; then
ID_QOS=`cat /etc/coyote/qos.classes | sed '$!d' | tr -s ' ' | cut -d " " -f 3 | sed 's/.$//' | sed 's/.//' | sed 's/.//'| sed 's/.//'`
TEST_VAR=`echo $(($ID_QOS)) | sed 's/.*\(.\)$/\1/g'`
	if [ $TEST_VAR = '9' -o $TEST_VAR = '0' -o $TEST_VAR = '1' ]; then
NOVA_ID_QOS=$((ID_QOS+4))
	else
NOVA_ID_QOS=$((ID_QOS+1))
	fi
  ROOTID='"1:1"'
  CLSID='"'1:$NOVA_ID_QOS'"'
CONFIG_LINE="$FORM_CLASSE $ROOTID $CLSID $FORM_DOWN_MIN $FORM_DOWN_MAX $FORM_UP_MIN $FORM_UP_MAX $FORM_IP #$FORM_USER"
echo $CONFIG_LINE >> /etc/coyote/qos.classes
echo "sed -i '/$FORM_IP /d' /etc/coyote/qos.classes" >> /etc/automation/clientes/$FORM_USER
echo "/etc/rc.d/rc.qos > /dev/null" >> /etc/automation/clientes/$FORM_USER
echo "/etc/rc.d/rc.qos.custom > /dev/null" >> /etc/automation/clientes/$FORM_USER
/etc/rc.d/rc.qos > /dev/null
/etc/rc.d/rc.qos.custom > /dev/null
	fi
#<<
#>>
#Arquivo
echo "rm /etc/automation/clientes/$FORM_USER" >> /etc/automation/clientes/$FORM_USER
chmod +x /etc/automation/clientes/$FORM_USER

cat << CLEOF
<body>
<tr><center><div id=alerta>$ATaac $FORM_USER $ATaaq<br>$Wta</div></center></tr>
</body>
CLEOF
	cl_rebuildconf
		fi
fi
##>>
##>>
#PAGINA
cat << CLEOF

<body marginwidth="0" marginheight="0">

<form method="POST" action="automation.cgi">
<table class=maintable width=100%>
<tr><th colspan=2>Automation $VERSION</th></tr>
</table>
<table class=maintable width=100%>
<tr><td class=row1 align=right><b>$Ius: </b></td> <td class=row2 width="103">
	<input type="text" name="USER" size="14"></td>
	<td class=row3><input type="checkbox" name="FIREWALL" value="ON">$Pts (Firewall)</td></tr>

<tr><td class=row1 align=right><b>MAC:</b></td> <td class=row2 width="103">
	<input type="text" name="MAC" size="14"></td>
	<td class=row3><input type="checkbox" name="DHCP" value="ON">$Egb 
	- $Fab: <input type="text" name="LEASE" value="86400" size="3"></td></tr>

<tr><td class=row1 align=right><b>IP:</b></td> <td class=row2 width="103">
	<input type="text" name="IP" size="14"></td>
	<td class=row3><input type="radio" name="modo_qos" value="SUBREDES">$Psw<p>
	<input type="radio" name="modo_qos" value="QoS">$Ped | $Pee
	<input type="radio" value="define_class_qos" name="CLASSE" checked>$Phr<input type="radio" name="CLASSE" value="define_class_sfq">$Phs</td></tr>

<tr><td class=row1 align=right><b>Gateway:</b></td>  <td class=row2 width="103">
	<input type="text" name="GATEWAY" size="14"></td>
	<td class=row3><input type="checkbox" name="EC" value="ON">$ATaar
		<select size="1" name="EC_METD">
		<option value="0">$ATaak</option>
		<option value="1">$ATaal</option>
		</select></td></tr>
<tr><td class=row1 align=right><b>$ATaan:</b></td> 
	<td class=row2 width="103">
	<input type="text" name="DATA" size="2"></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>$Anm:</b></td> 
	<td class=row2 width="103">
	<input type="text" name="MASK" value="24" size="2"></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>$Phk:</b></td> 
	<td class=row2 width="103"><input type="text" name="UP_MIN" size="4"></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>$Phl:</b></td> 
	<td class=row2 width="103"><input type="text" name="UP_MAX" size="4"></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>$Phi:</b></td> 
	<td class=row2 width="103"><input type="text" name="DOWN_MIN" size="4"></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>$Phj:</b></td>  
	<td class=row2 width="103"><input type="text" name="DOWN_MAX" size="4"></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>LAN:</b></td>  
	<td class=row2 width="103"><select name=LAN>
     <option value=LAN1 `[ "$LAN" = "LAN1" ] && echo selected`>LAN1</option> 
CLEOF
 [ ! -z $IF_LOCAL2 ] && echo "<option value=LAN2 `[ "$LAN" = "LAN2" ] && echo selected`>LAN2</option>"
 [ ! -z $IF_LOCAL3 ] && echo "<option value=LAN3 `[ "$LAN" = "LAN3" ] && echo selected`>LAN3</option>"
 [ ! -z $IF_LOCAL4 ] && echo "<option value=LAN4 `[ "$LAN" = "LAN4" ] && echo selected`>LAN4</option>"
 [ ! -z $IF_WLAN ] && echo "<option value=WLAN `[ "$LAN" = "WLAN" ] && echo selected`>WLAN</option>"
 [ ! -z $IF_DMZ ] && echo "<option value=DMZ `[ "$LAN" = "DMZ" ] && echo selected`>DMZ</option>"
cat << CLEOF
</select></td><td class=row2></td></tr>
<tr><td class=row1 align=right><b>ConLimit:</b></td> 
	<td class=row2 width="103"><input type="text" name="CONLIMIT" size="4" value="0"></td><td class=row2></td></tr>
	<tr><td width="151"><p></td>
		<td width="103">
		<input type="submit" value="$ATaaf" name="ENVIAR" style="float: right"></p></td>
	<td class=row3><input type="checkbox" name="DESCADASTRAR" value="ON"><font color="#FF0000"><b>$ATaas
	</b></font><input type="submit" value="$ATaag" name="REMOVER"> 
	(<a href="$SCRIPT?action=ListClientes">$ATaaa</a>) -
	<a href="$SCRIPT?action=update">$ATaam</a></td></tr>
	</table>
</form>

CLEOF
##<<
##>>
#Update
if [ "$FORM_action" = "update" ]; then
Versao=`wget http://www.brazilfw.com.br/users/daniel.uramg/2.3x/automation1.0/ver.ini -O -`
VerNova=`wget http://www.brazilfw.com.br/users/daniel.uramg/2.3x/automation1.0/vernova.ini -O -`
	if [ "$VERSION" != "$Versao" ]; then
cd /tmp
wget $VerNova > /dev/null
tar -xvzf /tmp/automation.tgz -C / > /dev/null
rm /tmp/automation.tgz
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaav: $VERSION $ATaaw: $Versao !</div></b></center></tr>
</body>
CLEOF
	else
cat << CLEOF
<body>
<tr><center><b><div id=alerta>$ATaau</div></b></center></tr>
</body>
CLEOF
	fi
		fi
##<<
##>>
##Lista de Clientes
if [ "$FORM_action" = "ListClientes" ]; then

echo '<table class=maintable border=0 width=\"100%\"><tr><th>'$ATaat:'</th></tr><tr><td><pre>'
	ls /etc/automation/clientes/ -1
fi
##<<

cl_footer2